%funksjon som tar inn et sett med feiltrunkerte observerte levetider T
%-simulerer l samples fra T vha Gibbs Block algorithm
%som brukes til  bestemme fordelingen til Kuiper test statistic
%slik at inferens angende hypotesen at T er fra log linear NHPP kan
%gjres.

function y=f(T,l)
tic
n=length(T);
m=n-1;
t=T/T(n);
s=sum(t(1:m));
teller=0;

%-----finn test statistic for datasett-----
bstart=-2;                      
mlb=feval(@estmlb,bstart,sum(t),n);

for j=1:m,
    v(j)=(exp(mlb*t(j))-1)/(exp(mlb)-1);
end
vbar=(1/m)*sum(v);
vb=m*(vbar-0.5)^2;
Wdata=1/(12*m)-vb;
for i=1:m,
    Wdata = Wdata + ((2*i-1)/(2*m)-v(i))^2;
end
%-----da har jeg funnet W=W(T) for observert datasett-----

%---startvektor---
x(1:m)=s/m;

%generer l samples vha Gibbs
for j=1:l,
    %---trekk i<j uten tilbakelegging---
    j1=floor(rand*m)+1;
    j2=floor(rand*(m-1))+1;
    if j2>=j1,
        j2=j2+1;
    else
        cd=j1;
        j1=j2;
        j2=cd;
    end
    k=x(j1)+x(j2);
    %---trekk x(i)^(m+1),x(j)^(m+1)
    if k<=1,
        x(j1)=rand*k;
        x(j2)=k-x(j1);
       
        else
        x(j1)=(k-1)+rand*(2-k);
        x(j2)=k-x(j1);
        
    end
    %---regn ut test statistic for sample---
    u=sort(x);
    for i=1:m,
        vs(i)=(exp(mlb*u(i))-1)/(exp(mlb)-1);
    end
    
    vbars=(1/m)*sum(vs);
    vbs=m*(vbars-0.5)^2;
    Wsample=1/(12*m)-vbs;
    for i=1:m,
        Wsample = Wsample + ((2*i-1)/(2*m)-vs(i))^2;
    end

    if Wsample>=Wdata,
        teller =teller+1;
    end
end
pverdi=teller/l
toc
%-----funksjon som regner ut mle for b, vha Newtons metode-----
function z=estmlb(bstart,s,n)
MaxIter=200;
iter=0;
bhelp=bstart;
while iter<MaxIter
    fb=s+n/bhelp-n/(1-exp(-bhelp));
    fbd=(-n/bhelp^2)+ (n*exp(-bhelp))/(1-exp(-bhelp))^2;
    bhelp=bhelp-fb/fbd;
    iter=iter+1;
end
z=bhelp;
%-----funksjon slutt-----