%funksjon som tar inn et sett med feiltrunkerte observerte levetider T
%-simulerer l samples fra T gitt suffisient observator S,
%som brukes til  bestemme fordelingen til Greenwood test statistic
%slike at inferens angende hypotesen at T er fra log linear NHPP kan
%gjres.
%-et plott av 5 simulerte sampler samt observerte data gis
%-et plott av 5 simulerte V*(T_s) samt V*(T) basert p observerte data gis
%-det gis et eksakt konfidensintervall for ukjent parameter b i modellen
%nr konvergens sammenligning kjres m alle undvendige operasjoner tas ut

function y=f(T,l)

%tic
n=length(T);        
M=n-1;              %antallet random variables som skal trekkes fra f(t)
tn=T(n);            %siste feiltid, her stopper observasjonene
Tu=T/tn;            %skalerer feiltidene mellom [0,1]
sn=sum(Tu);         %denne brukes i mlb
s=sn-1;             %suffisient observator

teller=0;           %disse brukes i vektingen
nevner=0;
%sjekk=[];
%sample=[];
%vstar=[];

%-----regner ut test statistic for observert datasett, da trenger vi
%mle for b, og denne brukes ogs til  regne ut test statistic for 
%alle samplene vi genererer under-----

bstart=-2;                      %trenger en startverdi for b
mlb=feval(@estmlb,bstart,sn,n);


%finn vj, for j=1:n, v0=0,og vn=1
for j=1:M,
    v(j)=(exp(mlb*Tu(j))-1)/(exp(mlb)-1);
end
v(n)=1;

%-----regner ut W(T)=(v(j)-v(j-1))^2 for observert datasett
Wdata=v(1)^2;
for i=2:n,
    Wdata=Wdata + (v(i)-v(i-1))^2;
end
%Wdata
%-----da har jeg funnet G=G(T) for observert datasett-----


%-----da gr vi over til  generere samples gitt S=s og regner ut test
%statistic G for hver sample-----
konb=[];               %i denne lagrer jeg b for hver sample
for j=1:l,
    
    u=rand(1,M);        %trekker n-1 tall mellom [0,1]

    %-----regner ut verdien f'(b=0)-----
    fd=sum(u)-s;
    %-----denne brukes til  finne ut hvor p x-aksen lsningen ligger

    %-----dersom fd>10^10 vet vi at lsning b<0-----
    if fd > 10^(-10),   
        help=0;
        for i=1:10000,
            help=help-1;
       
            if feval(@f,u,help,s,M) > 0 break
            end
        end
        b1=help;                         %vet n at lsning ligger i intervallet [b1,b2]
        b2=help+1;
        tol=0.00001;
        diff=abs(b1-b2);
        MaxIter=50;
        iter=0;
        while (diff>tol & iter<MaxIter)  %bruker halveringsmetode for  estimere b
            w=(b1+b2)/2;
            if feval(@f,u,w,s,M) > 0 
                b1=w;
            else
                b2=w;
            end
        diff=abs(b1-b2);
        iter=iter+1;
        end
        b=w;
    end
    %-----da har vi funnet lsning b < 0-----

    %-----dersom fd < -10^-10 vet vi at lsningen b>0-----
    if fd < -10^(-10),   
        help=0;
        for i=1:10000,
            help=help+1;
       
            if feval(@f,u,help,s,M) > 0 break
            end
        end
        b2=help;                         %vet n at lsning ligger i intervallet [b1,b2]
        b1=help-1;
        tol=0.00001;
        diff=abs(b1-b2);
        MaxIter=500;
        iter=0;
        while (diff>tol & iter<MaxIter)  %bruker halveringsmetode for  estimere b
            w=(b1+b2)/2;
            if feval(@f,u,w,s,M) > 0 
                b2=w;
            else
                b1=w;
            end
            diff=abs(b1-b2);
            iter=iter+1;
        end
        b=w;
    end
    %-----da har vi funnet lsning for b > 0-----

    %-----fd er 0 i b=0 spesialtilfelle-----
    if fd >=  -10^(-10) & fd <= 10^(-10)
        b=0;            %hvordan blir sample da?? HPP prosess
    end
    %-----ferdig med spesialtilfelle-----

    %konb=[konb b/tn];
    %-----har da funnet verdi for b og kan regne ut sample-----
    tu=[];
    u=sort(u);
    for i=1:M,
        tu(i)=log(1+u(i)*(exp(b)-1))/b;
    end
    %tar vare p 5 simulerte samples som brukes i plott under
    %if j<=5,
    %    tu(n)=1;
    %    x=tu*tn;
    %    sample=[sample; x];
    %end
    
    %-----regn ut test statistic W for denne sample-----
    %-----finn vs(j), for j=1:n, v0=0,og vn=1-----
    for i=1:M,
        vs(i)=(exp(mlb*tu(i))-1)/(exp(mlb)-1);
    end
    vs(n)=1;
    %-----da er v'ene p plass-----
    %tar vare p 5 simulerte V*(T_s) som brukes i plott under
    %if j<=5,
    %    vstar=[vstar;vs];
    %end
    
    %-----regn ut W(tu) for denne sample-----
    Wsample=vs(1)^2;
    for i=2:n,
        Wsample=Wsample + (vs(i)-vs(i-1))^2;
    end
    %W(j)=Wsample; %tar vare p simulert verdi for testobservator G
    
    %-----da m tau' og f(b) (kalles fb2) finnes for  vekte-----
    %fb2=1;
    %fb2=1/abs(b);
    fb2=sqrt(1/b^2 + 1/(2-(exp(b)+exp(-b))));      %'jeffreys prior'
    
    taud=-s/b;
    for i=1:M,
        taud=taud + (exp(b)/b)*u(i)/(1+u(i)*(exp(b)-1));
    end
    taud=abs(taud);
    vekt=abs(fb2/taud);
    %if vekt>10,
     %   vekt=0;
    %end
    
    nevner=nevner + vekt;
    if Wsample<=Wdata
        teller=teller + vekt;
    end
    %sjekk(j)=vekt;
end
%returnerer observert p-verdi
pverdi=teller/nevner;
pvalue=2*(min(pverdi,1-pverdi));
y=pvalue;
%toc

% % figw=14;
% % figh=8;
% % fontsa=10;
% % fonts=15;
% % posa=[0.11 .135 .86 .85];
% 
% %bestemmer strrelse p plott og plotter fordelingen til vektene
% figw=14;
% figh=8;
% fontsa=10;
% fonts=15;
% posa=[0.10 .13 .87 .85];
% figure();
% hold on
% set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
% set(gca,'fontsize',fontsa,'position',posa)
% 
% hist(sjekk,100);
% %xlabel('Weigths')
% %ylabel('Number of observations')
% antall=sum(sjekk==0)
% 
% %plotter et 90 prosent konfidensintervall for b
% figure(99)
% hist(konb,100);
% yl=ylim;
% close 99
% 
% figure();
% hold on
% set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
% set(gca,'fontsize',fontsa,'position',posa)
% ylim(yl);
% konb=sort(konb);
% % konf1=konb(0.05*l)/tn;
% % konf2=konb(0.95*l)/tn;
% konf1=konb(0.05*l);
% konf2=konb(0.95*l);
% konfidensintervall=[konf1 konf2]
% line([konf1,konf1],[yl],'color','r','linestyle','-')
% legend(['90% conf.int.'])
% hist(konb,100);
% line([konf1,konf1],[yl],'color','r','linestyle','-')
% line([konf2,konf2],[yl],'color','r','linestyle','-')
% %ylabel('Number of observations')
% %xlabel('b(U,s)')
% hold off
% 
% e=[zeros(1,n)];
% %gir et plott av simulerte feiltider for 5 sampler samt observert datasett
% figure();
% hold on
% set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
% set(gca,'fontsize',fontsa,'position',posa)
% plot(sample(1,:),e+1,'X',sample(2,:),e+2,'X',sample(3,:),e+3,'X',sample(4,:),e+4,'X',sample(5,:),e+5,'X',T,e+6,'X','markersize',7,'color',[0,0,0]);
% axis([0 8245 0 6.05])
% set(gca,'ytick',[0 1 2 3 4 5 6],'yticklabel','|T_s|T_s|T_s|T_s|T_s|T')
% set(gca,'xtick',[0 1000 2000 3000 4000 5000 6000 7000 8000 8245],'xticklabel','0|1000|2000|3000|4000|5000|6000|7000||8245')
% line([0,8245],[6,6],'color','r','linestyle','-')
% line([0,8245],[5,5],'color','b','linestyle','-')
% line([0,8245],[4,4],'color','b','linestyle','-')
% line([0,8245],[3,3],'color','b','linestyle','-')
% line([0,8245],[2,2],'color','b','linestyle','-')
% line([0,8245],[1,1],'color','b','linestyle','-')
% xlabel('t')
% hold off
% 
% %gir et plott av 5 V*(T_s) basert p simulerte samples samt V*(T) basert p
% %observert datasett
% posa=[0.115 .125 .86 .85];
% figure();
% hold on
% set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
% set(gca,'fontsize',fontsa,'position',posa)
% plot(v,e+6,'X',vstar(1,:),e+1,'X',vstar(2,:),e+2,'X',vstar(3,:),e+3,'X',vstar(4,:),e+4,'X',vstar(5,:),e+5,'X','markersize',7,'color',[0,0,0]);
% axis([0 1 0 6.05])
% set(gca,'ytick',[0 1 2 3 4 5 6],'yticklabel','|V*(T_s)|V*(T_s)|V*(T_s)|V*(T_s)|V*(T_s)|V*(T)')
% line([0,1],[6,6],'color','r','linestyle','-')
% line([0,1],[5,5],'color','b','linestyle','-')
% line([0,1],[4,4],'color','b','linestyle','-')
% line([0,1],[3,3],'color','b','linestyle','-')
% line([0,1],[2,2],'color','b','linestyle','-')
% line([0,1],[1,1],'color','b','linestyle','-')
% %xlabel('V^{\ast}')
% hold off
% 
% 
% %plotter fordelingen til testobservatoren G under antagelsen at datasett
% %kommer fra log linear NHPP
% figw=14;
% figh=8;
% fontsa=10;
% fonts=15;
% posa=[0.12 .11 .86 .86];
% 
% figure(77);
% hist(W,100);
% yl=ylim;
% close(77)
% %plotter histogram av testobservatoren
% figure();
% hold on
% set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
% set(gca,'fontsize',fontsa,'position',posa)
% ylim(yl);
% line([Wdata,Wdata],[yl],'color','r','linestyle','-')
% legend(['g_{obs}=' num2str(Wdata)])
% hist(W,100);
% line([Wdata,Wdata],[yl],'color','r','linestyle','-')
% xl=xlim;
% xlim([0 xl(2)])
% %xlabel('G')

%norm(vekt,inf)
%-----funksjon som regner ut verdien f(b)-----
function y=f(u,bf,s,M)        
y=-bf*s;                      
for j=1:M,
    y=y+log(1+u(j)*(exp(bf)-1));
end
%-----funksjon slutt-----

%-----funksjon som regner ut mle for b, vha Newtons metode-----
function z=estmlb(bstart,sn,n)
MaxIter=200;
iter=0;
bhelp=bstart;
while iter<MaxIter
    fb=sn+n/bhelp-n/(1-exp(-bhelp));
    fbd=(-n/bhelp^2)+ (n*exp(-bhelp))/(1-exp(-bhelp))^2;
    bhelp=bhelp-fb/fbd;
    iter=iter+1;
end
z=bhelp;
%-----funksjon slutt-----