%Tester styrken til Kolmogorov-Smirnov mot  forkaste feilsensurerte datasett
%fra power law, under nullhypotese at datasett er fra log linear NHPP
%Gibbs block algoritme brukes til  simulere datasett under nullhypotesen.

function y=f(ant,l)
tic
%b=[0.1:0.1:0.5 0.6:0.5:1.6];
b=[1.5]
for nn=1:length(b),

count=0;
for q=1:ant,
    
    T=feval(@simpowerlaw,10000,100,b(nn));
    
    n=length(T);
    m=n-1;
    t=T/T(n);
    s=sum(t(1:m));
    teller=0;

    %-----finn test statistic for datasett-----
    bstart=-2;                      
    mlb=feval(@estmlb,bstart,sum(t),n);
    for j=1:m,
        v(j)=(exp(mlb*t(j))-1)/(exp(mlb)-1);
    end
    for i=1:m,
        D1(i)=i/m-v(i);
    end
    for i=1:m,
        D2(i)=v(i)-(i-1)/m;
    end
    Wdata=max(max(D1),max(D2));
    %-----da har jeg funnet W=W(T) for observert datasett-----
    %---startvektor---
    x(1:m)=s/m;
    %---trekk i<j uten tilbakelegging---

    for j=1:l,
    
        j1=floor(rand*m)+1;
        j2=floor(rand*(m-1))+1;
        if j2>=j1,
            j2=j2+1;
        else
            cd=j1;
            j1=j2;
            j2=cd;
        end
        k=x(j1)+x(j2);
        %---trekk x(i)^(m+1),x(j)^(m+1)
        if k<=1,
            x(j1)=rand*k;
            x(j2)=k-x(j1);
       
        else
            x(j1)=(k-1)+rand*(2-k);
            x(j2)=k-x(j1);
        
        end
        %---regn ut test statistic for sample---
        u=sort(x);
        for i=1:m,
            vs(i)=(exp(mlb*u(i))-1)/(exp(mlb)-1);
        end
    
        for i=1:m,
        D1s(i)=i/m-vs(i);
        end
        for i=1:m,
            D2s(i)=vs(i)-(i-1)/m;
        end
        Wsample=max(max(D1s),max(D2s));

        if Wsample>=Wdata,
            teller =teller+1;
        end
    end
    pverdi=teller/l;
    if pverdi<=0.05,
        count=count+1;
    end
end
powertest=count/ant
%fnn(nn)=powertest
end
%plot(b,fnn);
toc    
%-----funksjon som regner ut mle for b, vha Newtons metode-----
function z=estmlb(bstart,s,n)
MaxIter=200;
iter=0;
bhelp=bstart;
while iter<MaxIter
    fb=s+n/bhelp-n/(1-exp(-bhelp));
    fbd=(-n/bhelp^2)+ (n*exp(-bhelp))/(1-exp(-bhelp))^2;
    bhelp=bhelp-fb/fbd;
    iter=iter+1;
end
z=bhelp;
%-----funksjon slutt-----