%-funksjon som tar inn et sett med observerte feilsensurerte feiltider z 
%-simulerer l nye sampler gitt verdi av suffisient observator S=s vha LT(2006)
%-lager et plott av de 5 siste simulerte samplene, samt observerte feiltider
%-lager et 90 prosent konfidensintervall for ukjent parameter b i modell
function x = f(z,l);
close all
n=length(z);
M=n-1;
t=z(n);     %siste observerte feiltidspunkt
x=[];       %lagrer hver enkelt simulerte sample
e=[zeros(1,n)];

c=[]; %lagrer verdiene for estimert verdi b, til konfidensintervallet

%finner sufficient statistic
s=sum(log(z(1:M)));

%genererer l samples som oppfyller s
for i=1:l,
    u=rand(1,M);
    u=sort(u);
    k=sum(log(u(1:M)));
    b=k/(s-M*log(t));
    bhat=1/b;
    y=[];
    for i=1:M,
        y(i)=t*(u(i)^bhat);
    end
    c=[c b];
    x=[x;y t];
end
%tar ut de fem siste simulerte samplene til plott
e2=[x(l-1,:)];
e3=[x(l-2,:)];
e4=[x(l-3,:)];
e5=[x(l-4,:)];
e6=[x(l-5,:)];

%noen justeringer for strrelse av plott
figw=14;
figh=8;
fontsa=10;
fonts=15;
posa=[0.10 .13 .87 .85];
%lager plott av 5 siste simulerte sampler samt observert datasett
figure();
hold on
set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
set(gca,'fontsize',fontsa,'position',posa)

plot(e2,e+1,'X',e3,e+2,'X',e4,e+3,'X',e5,e+4,'X',e6,e+5,'X',z,e+6,'X','markersize',7,'color',[0 0 0]);
axis([0 8245 0 6.05])
set(gca,'ytick',[0 1 2 3 4 5 6],'yticklabel','|T_s|T_s|T_s|T_s|T_s|T')
set(gca,'xtick',[0 1000 2000 3000 4000 5000 6000 7000 8000 8245],'xticklabel','0|1000|2000|3000|4000|5000|6000|7000||8245|')
line([0,8245],[6,6],'color','r','linestyle','-')
line([0,8245],[5,5],'color','b','linestyle','-')
line([0,8245],[4,4],'color','b','linestyle','-')
line([0,8245],[3,3],'color','b','linestyle','-')
line([0,8245],[2,2],'color','b','linestyle','-')
line([0,8245],[1,1],'color','b','linestyle','-')
xlabel('t')
hold off

%vi finner et 90% konfidensintervall for b
figure(99);
hist(c,100);
yl=ylim;
close 99

figure();
hold on
set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
set(gca,'fontsize',fontsa,'position',posa)
ylim(yl);
c=sort(c);
h=0.9;
m=l;
k=round((m+1)*(1-h)/2);
bconf=[c(k) c(m-k+1)]
line([bconf(1),bconf(1)],[yl],'color','r','linestyle','-')
legend(['90% conf.int.'])%[' num2str(bconf(1)) ',' num2str(bconf(2)) ']'
hist(c,100);
line([bconf(1),bconf(1)],[yl],'color','r','linestyle','-')
line([bconf(2),bconf(2)],[yl],'color','r','linestyle','-')
%ylabel('Number of observations')
%xlabel('b(U,s_2)')
hold off