%-funksjon som tar inn et sett med feilsensurerte observerte levetider z 
%-simulerer fordelingen til Watson test statisic, under antagelsen
%at z kommer fra en NHPP power law modell. Fordelingen kan simuleres 
%vha en random vektor Uniform(0,1)
%-Returnerer en p-verdi som brukes til  gjre inferens
% angende nullhypotesen
%-gir et plott av simulert fordeling til U^2

function q=f(z,l);
n=length(z);
M=n-1;
t=z(n);     %siste tidspunkt for feil

%finner sufficient statistic
s=sum(log(z(1:M)));

%finner b basert p MLE
bstar=n/(M*log(t)-s); 

%finner test statistic for datasett
UData=0;
    for i=1:M,
        UData=UData+(z(i)/t)^bstar;
    end
    UDM=(1/M)*UData;
    wData=M*(UDM-0.5)^2;
    summ2=0;
    for i=1:M,
        summ2=summ2+((2*i-1)/(2*M)-(z(i)/t)^bstar)^2;
    end
gdata=1/(12*M)+summ2-wData;

U=[];
%genererer fordeling til U^2 vha u
for i=1:l,
    u=rand(1,M);
    u=sort(u);
    k=sum(log(u(1:M)));
    bhat=k/(s-M*log(t));
    
    %finner test statistic Watson
    v=[];
    for i=1:M,
        v(i)=u(i)^(-n/k);   
    end
    
    UM=(1/M)*sum(v(1:M));
    
    w=M*(UM-0.5)^2;
    summ=0;
    for i=1:M,
        summ=summ+ ((2*i-1)/(2*M)-v(i))^2;
    end
    g=1/(12*M)+summ-w;
    U=[U g];
    
end

p=sum(U>gdata)/l
 
%bestemmer strrelse p figur
figw=7;
figh=5;
fontsa=10;
fonts=15;
posa=[0.12 .11 .86 .86];

%plotter fordelingen til Watson 
figure();
hist(U,100);
yl=ylim;
close all

figure();
hold on
set(gcf,'units','centimeters','position',[4 4 figw figh],'paperunits','centimeters','papersize',[figw figh])
set(gca,'fontsize',fontsa,'position',posa)
ylim(yl);
line([gdata,gdata],[yl],'color','r','linestyle','-')
legend(['u^2_{obs}=' num2str(gdata)])
hist(U,100);
line([gdata,gdata],[yl],'color','r','linestyle','-')
xl=xlim;
xlim([0 xl(2)])
%ylabel('Number of observations')
%xlabel('W^2(T_s)')
hold off


 